from flask import current_app, jsonify, request
from flask_restful import Resource
from flask_restful.reqparse import RequestParser
from flask_jwt_extended import ( jwt_required, get_jwt_identity )
from application.signal_manager import signalManager
{%- set pipe = joiner(",") %}
from models.{{ config['name'] }} import {% for k, v in config["view"].items() -%}
{{ pipe() }}{{ k }}{{ config['name'] | letterUpper }}Schema
{%- endfor %}
from webcreator.response import ResponseCode, response_result

class {{ config['controller']['className'] | letterUpper }}(Resource):
    def __init__(self):
        pass
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser = RequestParser()

{% if config["view"]["getList"] %}
    @jwt_required
{%- endif %}
    def get(self):
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser.add_argument("page", type=int, location="args", default=1)
        # self.parser.add_argument("pageSize", type=int, location="args", default=15)
        # args = self.parser.parse_args()

        try:
            json_payload = request.json
            print("========>", json_payload)
            data = getList{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionGet{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = getList{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)

{% if config["view"]["post"] %}
    @jwt_required
{%- endif %}
    def post(self):
        try:
            json_payload = request.json
            data = post{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionPost{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = post{{ config['name'] |letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)

class {{ config['controller']['className'] | letterUpper }}List(Resource):
    def __init__(self):
        pass
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser = RequestParser()

{% if config["view"]["get"] %}
    @jwt_required
{%- endif %}
    def get(self):
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser.add_argument("page", type=int, location="args", default=1)
        # self.parser.add_argument("pageSize", type=int, location="args", default=15)
        # args = self.parser.parse_args()

        try:
            json_payload = request.json
            print("========>", json_payload)
            data = get{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionGet{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = get{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)

{% if config["view"]["put"] %}
    @jwt_required
{%- endif %}
    def put(self):
        try:
            json_payload = request.json
            data = put{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionPut{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = put{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)

{% if config["view"]["delete"] %}
    @jwt_required
{%- endif %}
    def delete(self):
        try:
            json_payload = request.json
            data = delete{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionDelete{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = delete{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)